#include <stdio.h>
#include <allegro.h>

#include "prjxmain.h"
#include "map.h"

int MAP_MovePlayer(int pdir)
{
   switch(pdir)
   {
      case 0:                    // *!* UP
         if(PL_player.y > 14)
         {
            PL_player.y -=1;
            MAP_DisplayMap();
         }
         break;
      case 1:                    // *!* DOWN
         if(PL_player.y < 490)
         {
            PL_player.y += 1;
            MAP_DisplayMap();
         }
         break;
      case 2:                    // *!* LEFT
         if(PL_player.x > 18)
         {
            PL_player.x -= 1;
            MAP_DisplayMap();
         }
         break;
      case 3:                    // *!* RIGHT
        if(KeyWay < 490)
         {
            PL_player.x += 1;
            MAP_DisplayMap();
         }
         break;
   }
   return(0);
}

int MAP_LoadBG(void)
{
   PALLETE pallete1;

   TGA_MapBG=load_bitmap("GRAFIX\\MAP_BG.TGA",pallete1);
   return(0);
}

int MAP_DisplayBG(void)
{
   blit(TGA_MapBG,screen,0,0,0,0,320,200);
   return(0);
}

int MAP_DisplayMap(void)
{
   int tempx,tempy;

   showtranspict("GRAFIX\\BL_16X16.TGA",0,0,5,55,150,59);
   for(tempy=0;tempy<160;tempy+=16)
   {
      for(tempx=0;tempx<272;tempx+=16)
      {
         blit(TGA_Tileset[Map[(tempx/16)+PL_player.x][(tempy/16)+PL_player.y].tile],screen,0,0,tempx,tempy,16,16);
         masked_blit(TGA_Tileset[Map[(tempx/16)+PL_player.x][(tempy/16)+PL_player.y].layer2],screen,0,0,tempx,tempy,16,16);
      }
   }
//   masked_blit(TGA_TileSelect,screen,0,0,128,64,16,16);
//   showtiles();
   clear_keybuf();
   return(0);
}

int MAP_LoadMap(void)
{
   PACKFILE *infile;
   int temp1,temp2;

   infile = pack_fopen("DAT\\MAP.DAT", "rp");
   if (infile == NULL)
   {
      return(0);
   }
   pack_fread(&Map,sizeof(Map),infile);
   pack_fclose(infile);
   return(0);
}

int MAP_LoadTiles(void)
{
   int tempx,tempy,tmptile;
   PALLETE pallete1;

   tmptile=0;

   TGA_MapTiles=load_bitmap("GRAFIX\\MAPTILES.TGA",pallete1);
   for(tempy=0;tempy<192;tempy+=16)
   {
      for(tempx=0;tempx<320;tempx+=16)
      {
         TGA_Tileset[tmptile]=load_bitmap("GRAFIX\\BL_16X16.TGA",pallete1);
         blit(TGA_MapTiles,TGA_Tileset[tmptile],tempx,tempy,0,0,16,16);
         tmptile++;
      }
   }
   return(0);
}

int MAP_LoadGame(void)
{

   return(0);
}

int MAP_SaveGame(void)
{

   return(0);
}

int MAP_NewGame(void)
{
   if(MidiVol)
      playmidi("AUDIO\\NIGHTLND.MID"); // Start the music
   PL_player.x = 18;
   PL_player.y = 17;

   return(0);
}
